import { Ref } from 'react';

import classNames from 'classnames';
import { CheckboxProps, Checkbox as ReakitCheckbox } from 'reakit/Checkbox';

import { forwardRefWithAs, PropsWithAs } from '../utils';

function CheckboxComponent(
  {
    as: Type = 'input',
    checked,
    className,
    ...props
  }: PropsWithAs<CheckboxProps, 'input'>,
  ref: Ref<HTMLInputElement>
) {
  return (
    <ReakitCheckbox
      as={Type}
      checked={checked}
      className={classNames(
        'checkbox w-4 h-4 rounded border-gray-soft appearance-none border focus:outline-none focus:ring-2 ring-offset-2 ring-primary-500 checked:border-primary-500 checked:bg-primary-500',
        className
      )}
      {...props}
      ref={ref}
    />
  );
}

export const Checkbox = forwardRefWithAs<CheckboxProps, 'input'>(
  CheckboxComponent
);
